"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable-next-line:no-var-requires
var plantuml = require("node-plantuml"); // there are no type definitions for this module :-(
/**
 * Class for generating a diagram from PlantUML code.
 */
var PlantUmlDiagramGenerator = /** @class */ (function () {
    function PlantUmlDiagramGenerator() {
    }
    /**
     * Promises to write a diagram as an image into a buffer.
     * @param plantUml The PlantUML code for the diagram.
     * @param imageFormat The format of the image to generate. (eg.: "png" or "svg")
     * @returns The promise of a buffer including the image of the diagram.
     */
    PlantUmlDiagramGenerator.prototype.generateFromCode = function (plantUml, imageFormat) {
        return new Promise(function (resolve, reject) {
            var chunks = new Array();
            var gen = plantuml.generate(plantUml, { format: imageFormat });
            gen.out.on("data", function (chunk) { return chunks.push(chunk); });
            gen.out.on("error", function (e) { return reject(e); });
            gen.out.on("end", function () { return resolve(Buffer.concat(chunks)); });
        });
    };
    return PlantUmlDiagramGenerator;
}());
exports.PlantUmlDiagramGenerator = PlantUmlDiagramGenerator;
